//
//  integrationAbscissas.hpp
//  psoui

#ifndef integrationAbscissas_hpp
#define integrationAbscissas_hpp

#include "qpso.h"
 
using namespace Eigen;

class integrationAbscissas
{
public:
    Vector3d tau;
    Vector3d radialWeights;
    MatrixXd simplexPoints;
    VectorXd simplexWeights;
    MatrixXd orthoRotation;
    MatrixXd sigma;
    std::vector<std::vector<double> > Q, thetaSearchWeights;
    std::vector<std::vector<std::vector<std::vector<double> > > > thetaSearch;
    int Ns, Nq;
    int Nr = 3;
    VectorXd mu, a, b;
    std::vector<string> priorDistn;
    
public:
    integrationAbscissas();
    void performPriorConversion( std::vector<string> priors );
    void generateRadialQuantities(int p);
    void generateSimplexMethod(int p);
    void generateOrthoRotations(int p);
    void generateThetaSearchPoints(int p);
    void performPriorApproximation();
    
    void printSimplex();
    void printQ();
    
    Vector3d getTau;
    Vector3d getRadialWeights;
    VectorXd getSimplexPoints;
    VectorXd getSimplexWeights;
    double getNS(){return Ns;}
    
    
    
private:

};

#endif /* integrationAbscissas_hpp */
